package core.api.models.timemanager.taskSchedule;

import core.entities.timemanager.BasicTaskSchedule;
import core.entities.timemanager.ScheduleType;

import java.time.Duration;
import java.time.LocalDate;
import java.time.LocalDateTime;

public class ScheduleInfo {

    private long scheduleID;
    private ScheduleType scheduleType;
    private LocalDateTime startTime;

    private LocalDateTime finishTime;
    private int activeMinutes;

    private AbstractScheduleShortInfo schedule;

    public ScheduleInfo(BasicTaskSchedule basicTaskSchedule) {
        this.scheduleID = basicTaskSchedule.getScheduleID();
        this.scheduleType = ScheduleType.BASIC;
        this.startTime = basicTaskSchedule.getStartTime();
        this.finishTime = basicTaskSchedule.getFinishedTime();

        if(this.finishTime == null) {
            this.activeMinutes = (int) Duration.between(basicTaskSchedule.getStartTime(), LocalDate.now()).toMinutes();
        } else {
            this.activeMinutes = (int) Duration.between(basicTaskSchedule.getStartTime(), basicTaskSchedule.getFinishedTime()).toMinutes();
        }

        this.schedule = new BasicScheduleShortInfo(basicTaskSchedule);
    }

    public long getScheduleID() {
        return scheduleID;
    }

    public void setScheduleID(long scheduleID) {
        this.scheduleID = scheduleID;
    }

    public ScheduleType getScheduleType() {
        return scheduleType;
    }

    public void setScheduleType(ScheduleType scheduleType) {
        this.scheduleType = scheduleType;
    }

    public LocalDateTime getStartTime() {
        return startTime;
    }

    public void setStartTime(LocalDateTime startTime) {
        this.startTime = startTime;
    }

    public LocalDateTime getFinishTime() {
        return finishTime;
    }

    public void setFinishTime(LocalDateTime finishTime) {
        this.finishTime = finishTime;
    }

    public int getActiveMinutes() {
        return activeMinutes;
    }

    public void setActiveMinutes(int activeMinutes) {
        this.activeMinutes = activeMinutes;
    }

    public AbstractScheduleShortInfo getSchedule() {
        return schedule;
    }

    public void setSchedule(AbstractScheduleShortInfo schedule) {
        this.schedule = schedule;
    }
}
